//RTTY-Programm. Divisionen gehen in dem verwendeten C-Compiler nicht!

#include <at89x51.h>

#define	Takt	P3_5	// ENABLE-Eingang LCD-Anzeige 
#define	Bef_Dat	P3_7	// Auswahl Befehl/Daten LCD-Anzeige
#define	RX	P3_3	    // EmpfangsDaten vom XR-2211 

typedef unsigned char byte;
//Bitpositionen im Akku definieren:
sbit at 0xe0  ACC_0;
sbit at 0xe1  ACC_1;
sbit at 0xe2  ACC_2;
sbit at 0xe3  ACC_3;
sbit at 0xe4  ACC_4;
sbit at 0xe5  ACC_5;
sbit at 0xe6  ACC_6;
sbit at 0xe7  ACC_7;

const unsigned char anf_text[] = "RTTY-Monitor";
const unsigned char anf_text2[] ="Warte auf Zeichen";
const char RTTY_text[]=" e.a siu.drjnfcktzlwhypqobg.mxv";
const char RTTY_sonder[]=" 3.-..87.$4',!:(5')2#6019?&../;";

bit zeichen_zahl;//ob Buchstabe oder Zahl 
byte zeichen; //byte, welches aus den einzelnen empfangenen Bits zusammengesetzt wurde
byte hilfsbyte; //allgemeine verwendung

bit signal1,signal2,signal3,signal4,signal5;
bit ok;

byte 	position;	// Pointer auf die angezeigte Stelle
char	zeile[41];	// Inhalt unterste Zeile in LCD, POSITION ist der Index dazu
char    *zeiger;//zeigt auf das decodierte zeichen
char    test[20];

byte maxlen;  //lnge eine LCD-zeile (20 oder 40 Zeichen)

//----------------------UP-deklarationen ----------------------------
void LCD (byte); //UP welches die Bits dreht
void delay_kurz(void);
void delay(byte);//Funktion benutzt Timer 1!bergabewert ist nur eine Art Schalterwert

void lcd_befehl(byte); //sendet Befehl nach LCD-Anzeige
void lcd_write_char(char); //schreibt zeichen an aktueller position
void lcd_char_zeile(char); //schreibt zeichen an aktueller position und managed zeichenlnge des LCD-Displays
void warte_auf_stopbit(void);//wartet solange, bis ein Stopbit entdeckt wurde


//Funktionen fr die Entwicklung dieser Software:

/*
void zeige_t0(void);
void zeige_t1(void);
char int2hex(byte);
*/

//-------------------Programmbeginn----------------
void main (void)
{
 int i;	    // globale laufvariable
 P1=0;		// LCD-Anzeige auf 0
 Takt=0;
 IP=0x4;	// Interruptprioritt: START hchste P.
 EA=0;		// Interrupts verbieten
 EX0=0;		// ext. Interrupt 0 sperren
 EX1=0;		// ext. Interrupt 1 sperren
 TMOD=0x11;	// =00010001B Timermodus Timer0,1: Modus1
 maxlen=40; //LCD-Anzeige hat 40 zeichen pro Zeile, Vorgabewert

//       -----------------------------------------------
//              Initialisierung der LCD-Anzeige       
//       -----------------------------------------------

 Bef_Dat=0;	// LCD-Anzeige erhlt jetzt Befehle

// Zur Anfangsinitialisierung drei mal den Befehl zur Datenbusbreite abschicken

 delay(30);//Einschaltdauer LCD: 30mswarten 
 lcd_befehl(0x38); //=00111000B, Datenbus 8-Bit,2-zeilige Anzeige, 5*7 zeichengre

//jetzt zum zweiten mal:
 delay(10);//10ms warten
 Takt=1;	// Befehl abschicken 
 _asm
 nop
 _endasm;	// ein wenig warten
 Takt=0;

//jetzt zum 3. mal:
 delay(1);//1ms warten
 lcd_befehl(0x38); //=00111000B, Datenbus 8-Bit,2-zeilige Anzeige, 5*7 zeichengre
 for(i=1;i<3;i++) { delay_kurz();} //fr 200s warten

//Der LCD-Anzeige weitere Befehle senden
 lcd_befehl(0x01);//Clear Display
 delay(2);	  //2ms warten fr letzten Befehl

 lcd_befehl(0x0c); //Befehlscode: Anzeige einschalten, Kursor Aus
 lcd_befehl(0x06); //Befehlscode: Eintrittsmodus, RAM increment
 lcd_befehl(0x02); //Cursor home
 delay(2);	//2ms warten fr letzten Befehl

//begrungstext einschreiben:
// erste Zeile:

 for (i=0;anf_text[i]!=0;i++)
 {lcd_write_char(anf_text[i]);}
 
//zweite zeile
 lcd_befehl(0x0c0); //Kursor auf zweite Zeile (Adresse 40h) setzen

 for (i=0;anf_text2[i]!=0;i++)
 {lcd_write_char(anf_text2[i]);}


//LCD-Zeichenlnge feststellen:
 if (P3_4==1) {maxlen=20;}

//Anfangsinitialisierungen:
 for(i=0;i<41;i++){zeile[i]=' ';}
 position=0;

 lcd_befehl(0x0c0); //Kursor auf zweite zeile (Adresse 40h) setzen

 zeichen_zahl=0; //Standardeinstellung: Buchstaben sind aktiv

//===========================Hauptschleife=================================
Start:

//erst einmal auf ein Stoppbit warten 
warte_auf_stopbit();
//Startbit liegt jetzt an
ok=0;

neues_zeichen:
//jetzt eine Offset-Zeit abwarten, um in der Mitte des Impulses abzutasten:
delay(22); //22ms(lnge Startbit)+10ms Offset warten
delay(7);

//jetzt alle 22ms signal abtasten:
signal1=RX;
delay(22);
signal2=RX;
delay(22);
signal3=RX;
delay(22);
signal4=RX;
delay(22);
signal5=RX;
delay(22);

//jetzt mu das Stoppbit anliegen:
ok=RX;

if (ok==0){while(RX==0); goto warte_neues_zeichen;}//da war kein Stoppbit
//Ein Bitmuster wurde erkannt. jetzt auswerten:
hilfsbyte=A;//Akkuinhalt retten
A=0;//Akku lschen
ACC_0=signal1;
ACC_1=signal2;
ACC_2=signal3;
ACC_3=signal4;
ACC_4=signal5;

zeichen=A;
A=hilfsbyte;//Akkuinhalt wiederherstellen

//wenn es sich um ein Steuerzeichen handelt, auswerten:
if (zeichen==0x1F){zeichen_zahl=0;goto warte_neues_zeichen;}
if (zeichen==0x1B){zeichen_zahl=1;goto warte_neues_zeichen;}
if (zeichen>0x1F){goto neues_zeichen;}//grer als 1B gibt es keine Zeichen, deshalb Fehler

//wenn buchstabenseite aktiv:
if (zeichen_zahl==0)
 {zeiger=&RTTY_text;}
else
 {zeiger=&RTTY_sonder;}
zeiger=zeiger+zeichen;
lcd_char_zeile(*zeiger);

warte_neues_zeichen:
while(RX==1);//warten, bis neue Startflanke kommt
goto neues_zeichen;

} //Main


//-----------------UP-Routinen--------------------- 

void LCD(unsigned char zeichen) 
//Positioniert Bits fr die Ausgabe auf port 1
{
 ACC=zeichen;
 P1_0=ACC_0;
 P1_1=ACC_2;
 P1_2=ACC_4;
 P1_3=ACC_6;
 P1_4=ACC_7;
 P1_5=ACC_5;
 P1_6=ACC_3;
 P1_7=ACC_1;
 return;
}

void delay_kurz(void)
//Warteschleife fr 100s
{
 short j;
 for (j=1;j<40;j++);
 return;
}

void delay(byte wert)
//allgemeine Warteschleife, "wert" enthlt die Wartezeit in s 
{
 TR1=0;
 switch (wert)
 {
 case 1 :   TL1=0x05;
            TH1=0xFF;
            break;
 case 2 :   TL1=0x0B;
            TH1=0xFE;
            break;
 case 7 :   TL1=0x29;
            TH1=0xF9;
            break;
 case 10:   TL1=0x3B;
            TH1=0xF6;
            break;
 case 22:   TL1=0x83;
            TH1=0xEA;
            break;
 case 30:   TL1=0xC5;
            TH1=0xDF;
            break;
 default:   TL1=0x05;
            TH1=0xFF;
}
 TR1=1;
 while (TF1==0);
 TR1=0;
 TF1=0;
 return;
}

void lcd_befehl(byte z) //sendet Befehl nach LCD-Anzeige
{
 Bef_Dat=0;	//LCD bekommt Befehl
 LCD(z);
 Takt=1;
 _asm
 nop
 _endasm;
 Takt=0;
 delay_kurz();
 return;
}

void lcd_write_char(char z) //schreibt Zeichen an aktueller position
{
 Bef_Dat=1;	//LCD soll etwas anzeigen
 LCD(z);
 Takt=1;
 _asm
 nop
 _endasm;
 Takt=0;
 delay_kurz();
 return;
}

void lcd_char_zeile(char z)
{short lv;
//schreibt in der 2.zeile ein zeichen und managed Zeilenlnge und kopiert ggf. 2.zeile in die 1.zeile
 if (position==maxlen) //maximale Anzahl Zeichen pro LCD-zeile erreicht
 {
  lcd_befehl(0x01); //Clear display
  delay(2);
  for (lv=0;lv<maxlen;lv++) {lcd_write_char(zeile[lv]);} //zeichenkette nach erste Zeile schreiben
  position=0;
  lcd_befehl(0x0c0); //Kursor auf zweite Zeile (Adresse 40h) setzen
 }//if
 zeile[position]=z;
 lcd_write_char(z);
 position++;
 return;
}


void warte_auf_stopbit(void)//wartet solange, bis ein Stopbit entdeckt wurde
{
 /*folgende impulsbreiten enthalten das Stopbit:
 34,56,78,100,123 und 146ms. +- 2ms
 Zur Auswertung wird nur TH0 benutzt. 
 */
 byte j;

w_start:
 TR0=0;
 TH0=0;
 TL0=0;
 TF0=0;
 while(RX ==1); //Eventuelles High am Eingang abwarten
 while(RX ==0); //Am Eingang mu "0" anliegen
 TR0=1;
 while(RX ==1); //warten, bis Impuls vorrber ist
 TR0=0;

//Timerwert auswerten:
 if (TF0==1) {goto w_start;}
 if (TH0<0x10) {goto w_start;}//Wert war wirklich zu klein

 j=TH0;

 //werte kleiner als 10ms gleich abweisen:
 
/* frhere Version:
 if (j>31 && j<37)  {q='1';goto ende;}
 if (j>53 && j<59)  {q='2';goto ende;}
 if (j>75 && j<81)  {q='3';goto ende;}
 if (j>97 && j<103) {q='4';goto ende;}
 if (j>120 && j<126){q='5';goto ende;}
 if (j>142 && j<148){q='6';goto ende;}
 */
 if (j>0x1F && j<0x23) {goto ende;}/*Soll: 33ms. Spanne von 31,74ms bis 35,84ms*/
 if (j>0x34 && j<0x38) {goto ende;}/*Soll: 55ms. Spanne von 53,24ms bis 57,34ms*/
 if (j>0x49 && j<0x4D) {goto ende;}/*Soll: 77ms. Spanne von 74,7ms bis 78,8ms  */
 if (j>0x5F && j<0x64) {goto ende;}/*Soll: 99ms. Spanne von 97,2ms bis 102,4ms  */
 if (j>0x75 && j<0x7A) {goto ende;}/*Soll: 122ms.Spanne von 119,8ms bis 124,9ms  */
 if (j>0x8A && j<0x8F) {goto ende;}/*Soll: 144ms.Spanne von 141,3ms bis 146,4ms  */

 goto w_start;/*keine gltige Zeitspanne erkannt*/
ende:
 return;
}


/*
char int2hex(byte x)
{ char z;
 if (x <10) {z= x+'0';}
 else
 {z=x+'7';}
 return (z);
}

void zeige_t0(void) 
{//fr testausgabe TH0 und TL0 auf lcd anzeigen:
 char tc;
 byte q;

 lcd_befehl(0x0c0); //Kursor auf zweite zeile (Adresse 40h) setzen

//oberstes Nibble bergeben:
 q=TH0;
 q=q >>4;
// q=TL0 & 0xF0;
 tc=int2hex(q);
 lcd_write_char(tc);

 //unterstes Nibble bergeben;
 q=TH0 & 0x0f;
 tc=int2hex(q);
 lcd_write_char(tc);

//oberstes Nibble bergeben:
 q=TL0 & 0xf0;
 q=q >>4;
 tc=int2hex(q);
 lcd_write_char(tc);


 //unterstes Nibble bergeben;
 q=TL0;
 q=TL0 & 0x0f;
 tc=int2hex(q);
 lcd_write_char(tc);

 lcd_write_char(' ');
//testausgabe ende
 return;
}

void zeige_t1(void) 
{//fr testausgabe TH1 und TL1 auf lcd anzeigen:
 char tc;
 byte q;

 lcd_befehl(0x0c0); //Kursor auf zweite zeile (Adresse 40h) setzen

//oberstes Nibble bergeben:
 q=TH1;
 q=q >>4;
// q=TL0 & 0xF0;
 tc=int2hex(q);
 lcd_write_char(tc);

 //unterstes Nibble bergeben;
 q=TH1 & 0x0f;
 tc=int2hex(q);
 lcd_write_char(tc);

//oberstes Nibble bergeben:
 q=TL1 & 0xf0;
 q=q >>4;
 tc=int2hex(q);
 lcd_write_char(tc);


 //unterstes Nibble bergeben;
 q=TL1;
 q=TL1 & 0x0f;
 tc=int2hex(q);
 lcd_write_char(tc);

 lcd_write_char(' ');
//testausgabe ende
 return;
}
*/

